import gc
from __cantcomps import cantcomps
try: xrange
except: xrange = range


def multiplode (n, m):
	r = (n == n // m * m)
	return r


def encontrar_N_zeta (largo, zeta, bits, limiteMem=100000, mostrar=False, devolverR=False):
		Rmin = 2 ** bits
		Nmax = (largo * zeta) // 2
		default = [None] * (largo)
		default[1] = 1

		# ---------------- encontrar minimo N ---------------

		# si no existe solucion para comps sin restringir, tampoco existe restringiendo zeta
		if cantcomps (Nmax, largo) < Rmin:
			r = (None, None) if devolverR else None
			return r

		R = {}

		sufijo_max = [zeta * (L - 1) for L in xrange (largo + 1)]

		mem = [1 for n in xrange (largo + 1)]
		s0mem = [0 for n in xrange (largo + 1)]
		s1mem = [0 for n in xrange (largo + 1)]

		descartado = -1

		for n in xrange (Nmax + 1):
			R[n] = default[:]
			for L in xrange (2, largo + 1):
				if n < zeta * L + 1:

					# calcular rango del prefijo (p0, p1) y del sufijo (s0, s1)
					p0 = max (0, n - sufijo_max[L])
					p1 = min (zeta, n)
					s0 = n - p1
					s1 = n - p0

					# sumar el ultimo si s1 aumenta, restar el primero anterior si s0 aumenta
					s0g = s0mem[L]
					dif = R[s1][L - 1] if s1 > s1mem[L] else 0
					dif -= R[s0g][L - 1] if s0 > s0g else 0
					mem[L] += dif

					# guardar
					if not L == largo:
						R[n][L] = mem[L]
					s1mem[L] = s1
					s0mem[L] = s0

			if mem[largo] >= Rmin:
				# encontrado
				N = n
				r = (N, mem[largo]) if devolverR else N
				return r

			if multiplode (n, limiteMem):
				# mostrar progreso
				if mostrar:
					print ('%s/%s' % (n, Nmax))
				# descartar memoria
				d = min (s0mem[2:] + s1mem[2:])
				if d > descartado + 1:
					for m in xrange (descartado + 1, d):
						R.pop (m, None)
					gc.collect ()
					descartado = d - 1

		# no encontrado
		r = (None, None) if devolverR else None
		return r


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 128
	largo = 64
	zeta = 7

	N = encontrar_N_zeta (largo, zeta, bits)

	print ('bits, largo, zeta = ' + str ((bits, largo, zeta)))
	print ('R (N, largo, zeta) >= 2^bits')
	print ('N = ' + str (N))

